<!doctype html>
<?php
include('./include/config.inc.php');

if(!hasPermission("action_exit"))
{
	header('Location: index.php');
	die;
}

?>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="user-scalable=no, initial-scale=1, maximum-scale=1, minimum-scale=1, width=device-width">
	<meta name="mobile-web-app-capable" content="yes">
	<meta name="apple-mobile-web-app-capable" content="yes">
	<meta http-equiv="X-UA-Compatible" content="IE=edge"/>	
	<title>Waste Management System</title>
	<link rel="shortcut icon" href="favicon.ico">
	<link rel="stylesheet" href="css/jquery.mobile.structure.css">
	<link rel="stylesheet" href="css/jquery.mobile.theme.css">
	<link rel="stylesheet" href="css/jquery.mobile.icons.css">
	<link rel="stylesheet" href="css/wms.css">
	<link rel="stylesheet" href="css/wms.add.css">
	<script src="js/jquery.js"></script>
	<script src="js/jquery.mobile.js"></script>
	<script src="js/wms.js"></script>	
	
	<script>
		$( document ).on( "pagecreate", function() {
			$( "#selKunde" ).on( "click", "li", function() {
				$( "#kunde" ).val( $( this ).text() );  
				$( "#kundenid" ).val( $(this).attr("id") );
				$( "#debitor_id" ).val( $(this).attr("debitor_id") );				
				$( "#zahlung" ).val( $(this).attr("pay") ).selectmenu('refresh');
				//$( "#tarifid" ).val( $(this).attr("tariff") );
				$( "#selKunde li" ).addClass('ui-screen-hidden');
				$( "#cdesc" ).val ( $(this).attr("name1") + ' ' + 
									$(this).attr("name2") + ' - Freimenge: ' + 
									$(this).attr("quantity") );
			});
			$( "#selTarif" ).on( "click", "li", function() {
				$( "#tarif" ).val( $( this ).text() );  
				$( "#tarifid" ).val( $(this).attr("id") );
				$( "#selTarif li" ).addClass('ui-screen-hidden');
				$( "#tdesc" ).val( $( this ).text() );
			});		
		    $( "#selKunde" ).on( "filterablebeforefilter", function ( e, data ) {
		        var $ul = $( this ),
		            $input = $( data.input ),
		            value = $input.val(),
		            html = "";
		        	$ul.html( "" );		        	
		        if ( value && value.length > 2 ) {
		            $ul.html( "<li><div class='ui-loader'><span class='ui-icon ui-icon-loading'></span></div></li>" );
		            $ul.listview( "refresh" );
		            var path = window.location.pathname;
		            var pathName = path.substring(0, path.lastIndexOf('/') + 1);
		            var url = window.location.protocol + "//" + window.location.host + "/" + pathName;
		            var servlet = url + "servlet/search.php";
		            $.ajax({
		                url: servlet,
		                dataType: "jsonp",
		                crossDomain: true,
		                data: {
			                query: 'customer_list_wms',
		                    search: $input.val()
		                }
		            })
		            .then( function ( response ) {
		                $.each( response, function ( i, val ) {
			                html += '<li class="selKunde" ';
			                html += 'id="' + val.id + '" ';
			                html += 'pay="' + val.pay + '" ';
			                html += 'name1="' + val.name1 + '" ';
			                html += 'name2="' + val.name2 + '" ';
			                html += 'quantity="' + val.quantity + '" ';			                			                			                
			                html += 'tariff="' + val.tariff + '" ';
			                html += 'debitor_id="' + val.debitor_id + '">';
			                html += '<a class="href" href="#">';
			                html += val.id + '<br> ' + val.name1 + ' ' + 
	                		val.name2 + '<br>' + val.street + '<br>' + 
	                		val.zip + ' ' + val.city + '<br>' +
	                		'Freimenge: ' + val.quantity;
			                html += '</a>';
		                });
		                $ul.html( html );
		                $ul.listview( "refresh" );
		                $ul.trigger( "updatelayout");
		            });
		        }
		    });		
		    $( "#selTarif" ).on( "filterablebeforefilter", function ( e, data ) {
		        var $ul = $( this ),
		            $input = $( data.input ),
		            value = $input.val(),
		            html = "";
		        	$ul.html( "" );		        	
		        if ( value && value.length > 0 ) {
		            $ul.html( "<li><div class='ui-loader'><span class='ui-icon ui-icon-loading'></span></div></li>" );
		            $ul.listview( "refresh" );
		            var path = window.location.pathname;
		            var pathName = path.substring(0, path.lastIndexOf('/') + 1);
		            var url = window.location.protocol + "//" + window.location.host + "/" + pathName;
		            var servlet = url + "servlet/search.php";
		            $.ajax({
		                url: servlet,
		                dataType: "jsonp",
		                crossDomain: true,
		                data: {
			                query: 'weighing_tarif',
			                contact: $( "#kundenid" ).val(),
			                filter: $( "#filter" ).val(),
		                    search: $input.val()
		                }
		            })
		            .then( function ( response ) {
		                $.each( response, function ( i, val ) {
			                html += '<li class="selTarif"';
			                html += 'id="' + val.id + '">';			                
			                html += '<a class="href" href="#">';
			                html += val.description;
			                html += '</a>';
		                });
		                $ul.html( html );
		                $ul.listview( "refresh" );
		                $ul.trigger( "updatelayout");
		            });
		        }
		    });			    			
		});
	</script>  
			
</head>
<body>

<div data-role="page">
	<?php
	include('js/header.php');
	?>
	<?php
	include('js/menu.php');
	?>
	<div role="main" class="ui-content">
		<table>
		<?php 		
		
		$res = pg_query($db, 'select 
								a.id, 
								a.destination_appliance, 
								i.description as appl, 
								a.reference, 
								to_char(a.tara_in, \'999G990D00\') as tara_in, 
								to_char(a.tara_out, \'999990\') as tara_out, 
								a.start_timestamp,
								a.tariff,
								a.contact,
								a.card,
								a.paymenttype,
								coalesce(c.name1, \'\') || \' \' || 
									coalesce(c.name2, \'\') || 
									\' - Freimenge: \' || coalesce(cc.quantity, 0)::integer::text as cname,
								w.remark as alibi,
								a.remark,
								c.debitor_id,
								a.use_free,
								t.description
							from 
								activity a left outer join activity_weighing w on w.activity = a.id and w.weighing_type = \'exit\', 
								appliance i,
								contact c,
								card cc,
								tariff t
							where 
								a.id = '.$_GET['id'].' and 
								a.destination_appliance = i.id and 
								c.id = a.contact and
								cc.id = a.card and
								t.id = a.tariff
		');
		
		if ($row = pg_fetch_assoc($res)) {
			
			$tar = $row["tariff"];
			$card = $row["card"];
			$cname = $row['cname'];
			$tara_out = $row['tara_out'];
			$alibi = $row['alibi'];
			$remark = $row['remark'];
			$reference = $row['reference'];
			$debitor_id = $row['debitor_id'];
			$atxt = $row['description'];
			
			if (empty($row['use_free'])) 
				$use_free = '--';
			else
				$use_free = $row['use_free'];
			
			if ($card == '0')
			{
				$card = "";
			}
			$paym = $row["paymenttype"];
			
		?>
		<tr>
		<td><?php echo $row['reference']; ?></td>
		<td><?php echo $row['start_timestamp']; ?></td>
		<tr>
		<td><?php echo $row['tara_in']; ?></td>
		<td><?php echo $row['appl']; ?></td>		
		</tr>
		</table>	
			
		<?php 	
		}		
		?>
			
		<form id="myform" data-ajax="false" name="ausfahrt" action="./action_exit_save.php" method="POST" autocomplete="off">
		
		<input required style="background-color: #eee; cursor: not-allowed;" type="hidden" id="anlage" name="anlage" value=<?php echo $row["destination_appliance"]; ?>>				
		
		<input required type="hidden" id="id" name="id" placeholder="id" value="<?php echo $_GET['id']; ?>">
		
		<table>
		<tr>
		<td>		
		<input id="kunde" name="kunde" placeholder="Kunde" data-type="search" data-clear-btn="true">
 		<ul id="selKunde" name="selKunde" data-role="listview" data-inset="true" data-filter="true" data-filter-reveal="true" data-input="#kunde">	 			
		</ul>
		</td>
		<td>
		<input value="<?php echo $card; ?>" required style="background-color: #eee; cursor: not-allowed;" type="text" id="kundenid" name="kundenid" placeholder="Kunde">
		</td>
		<td>
		<input value="<?php echo $debitor_id; ?>" style="background-color: #eee; cursor: not-allowed;" type="text" id="debitor_id" name="debitor_id" placeholder="Debitor">				
		</td>		
		</tr>
		<tr>
		<td colspan="2">
		<input id="cdesc" name = "cdesc" type="text" value="<?php echo $cname; ?>" readonly>
		</td>
		<td>
		<div class="containing-element">
		<select data-mini="true" required name="use_free" id="use_free" data-role="slider">
    		<option value="ja" <?php if(($use_free == 't') or ($use_free == '--')) echo 'selected="true"'; ?>>anwenden</option>
    		<option value="nein" <?php if($use_free == 'f') echo 'selected="true"'; ?>>nicht anwenden</option>
		</select>	
		</div>			
		</td>
		</tr>		
		</table>
		
		<input id="remark" name="remark" placeholder="Bemerkung" type="text" data-clear-btn="true" value="<?php echo $remark; ?>">
		<input id="reference" name="reference" placeholder="Kennzeichen" type="text" data-clear-btn="true" value="<?php echo $reference; ?>" style="text-transform:uppercase">
				
		<fieldset data-role="controlgroup">	
			<?php
			$res = pg_query($db, 'select id, description from appliance where category = \'depot\' or id = \'0\' order by id');
			while ($row = pg_fetch_assoc($res)) {
			?>
				<input <?php if ($row['id'] == '0') echo 'checked="checked" '; ?> required type="radio" name="verbleib" id="v<?php echo $row['id']; ?>" value="<?php echo $row['id']; ?>">
				<label for="v<?php echo $row['id']; ?>"><?php if ($row['id'] == '0') echo "keine Umbuchung"; else echo "Umbuchung auf ".$row['description']; ?></label>
			<?php } ?>
		</fieldset>				
		
		<select value="<?php echo $paym; ?>" required id="zahlung" name="zahlung" data-native-menu="false">
		<option data-placeholder="true">--- Zahlungsart wählen ---</option>
		<?php
		$res = pg_query($db, 'select id, description, debitor from paymenttype order by description');
		while ($row = pg_fetch_assoc($res)) {
		?>
			<option
				<?php if ($row['id'] == $paym) echo 'selected '; ?> 
				value=<?php echo $row['id']; ?>
				debitor=<?php echo $row['debitor']; ?>
			>
			<?php echo $row['description']; ?>
			</option>
		<?php } ?>		
		</select>											

		<table>
		<tr>
		<td colspan="1">		
		<input id="tarif" name="tarif" placeholder="Tarif" data-type="search" data-clear-btn="true">
		<ul id="selTarif" name="selTarif" data-role="listview" data-inset="true" data-filter="true" data-filter-reveal="true" data-input="#tarif">
		</ul>
		</td>
		<td>
		<input required value="<?php if ($tar <> '0') echo $tar; ?>" style="background-color: #eee; cursor: not-allowed;" type="text" id="tarifid" name="tarifid" placeholder="Tarif">
		</td>
		<td colspan="1">
		<div class="containing-element">				
		<select required name="filter" id="filter" data-role="slider">
    		<option value="ja" selected="true">filtern</option>
    		<option value="nein">alle</option>
		</select>
		</div>		
		</td>						
		</tr>
		<?php
			if ($atxt <> '')
			{
		?>
		<tr>
		<td colspan="3">
		<input readonly id="tdesc" name="tdesc" value="<?php echo $atxt; ?>">		
		</td>
		</tr>
		<?php
			}
		?>
		<tr>
		<td colspan="2">
		<input required id="tara" name="tara" pattern="[0-9]*" type="text" placeholder="Gewicht" value="<?php echo trim($tara_out); ?>"/>
		</td>
		<td>		
		<input required style="background-color: #eee; cursor: not-allowed;" id="alibi" value="0" name="alibi" pattern="[0-9]*" type="text" placeholder="Alibispeicher" value="<?php echo $alibi; ?>"/>
		</td>
		<!-- 
		<td>
		<input id="menge" name="menge" pattern="[0-9]*" type="number" placeholder="optionale Menge für Tarif">
		</td>
		-->
		</tr>
		<td>
		<input id="do_start_weighing" name="do_start_weighing" type="button" onclick="JavaScript:start_weighing();" class="ui-shadow ui-btn ui-corner-all" data-mini="true" data-role="button" value="Waage">				
		</td>
		<td>
		<a data-mini="true" data-role="button" href="#weighing" data-rel="popup">?</a>
		<div data-role="popup" id="weighing" name="weighing">
			<iframe 
				name="do_weighing" 
				id="do_weighing" 
				src="action_weighing.php?appliance=0" 
				seamless 
				frameBorder="0" 
				width="200px" 
				height="200px" 
				scrolling="no"
				style="width:200px; height:200px; overflow:hidden;"				
			></iframe>		
		</div>				
		</td>
		<td>
		<input id="manuell" name="manuell" type="button" onclick="JavaScript:start_manuell();" class="ui-shadow ui-btn ui-corner-all" data-mini="true" data-role="button" value="Hand">				
		</td>				
		</tr>		
		</table>
		
		<table>
		<tr>
		<td>			
		<style type="text/css" media="screen">
		.containing-element .ui-slider-switch { width: 12em; }
		</style>			
		<div class="containing-element">				
		<select required name="weitere" id="weitere" data-role="slider">
    		<option value="nein" selected="true">letzter Tarif</option>
    		<option value="ja">weiterer Tarif</option>
		</select>
		</div>
		</td>
		</tr>
		<tr>
		<td>
		<style type="text/css" media="screen">
		.containing-element .ui-slider-switch { width: 12em; }
		</style>			
		<div class="containing-element">				
		<select required name="abschluss" id="abschluss" data-role="slider">
    		<option value="ja" selected="true">fertigstellen</option>
    		<option value="nein">nur speichern</option>
		</select>
		</div>		
		</td>
		</tr>
		</table>
			
		<input id="submit" type="submit" class="ui-shadow ui-btn ui-corner-all" data-icon="action" data-iconpos="top" value="Ausfahrt">
		
		</form>	
		
		<a class="ui-btn" href="action_exit_cancel.php?id=<?php echo $_GET['id']; ?>" data-ajax="false"><b>unerlaubte Ausfahrt</b></a>	
		<a class="ui-btn" href="action_exit.php" data-ajax="false"><b>Abbruch</b></a>		
		
		<script type="text/javascript">
		var forms = document.getElementsByTagName('form');
		for (var i = 0; i < forms.length; i++) {
	    	forms[i].noValidate = true;
	    	forms[i].addEventListener('submit', function(event) {
	        	//Prevent submission if checkValidity on the form returns false.
	        	if (!event.target.checkValidity()) {
	            	event.preventDefault();
	            	alert('Es wurden nicht alle notwendigen Felder eingegeben! Bitte die fehlenden Eingaben ergänzen!');
	        	} 
	        	else 
		        {
		        	if (
				        (document.getElementById("debitor_id").value == "") &&
				        (document.getElementById("zahlung").options[document.getElementById("zahlung").selectedIndex].getAttribute('debitor') == "")
				    ) 
					{
		        		event.preventDefault();
		        		alert('Diese Zahlungsart ist für diesen Kunden nicht erlaubt!');
		        	} 
		        	else 
			        {			        
		        		$("#myform").fadeOut();
		    			$.mobile.loading( "show", {
		    				text: 'Die Eingaben werden gespeichert! Bitte warten ...',
		    				textVisible: true,
		    				theme: 'a',
		    				html: ""
		    			});	
		        	}		
	        	} 			        	
	    	}, false);
		}
		</script>	
						
	</div>
	
	<?php
	include('js/footer.php');
	?>

</div>

</body>

<script>
function start_weighing() {
	
	document.getElementById("alibi").value = null;
	document.getElementById("tara").value = 0;	
	document.getElementById("do_weighing").src = "action_weighing.php?appliance="+document.getElementById("anlage").value;	
			
}
function start_manuell() {
	
	document.getElementById("alibi").value = 0;
	document.getElementById("tara").value = null;
	document.getElementById("tara").focus();	
			
}
</script>

</html>
