<!doctype html>
<?php
include('./include/config.inc.php');

if(!hasPermission("list_contact"))
{
	header('Location: index.php');
	die;
}

?>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="user-scalable=no, initial-scale=1, maximum-scale=1, minimum-scale=1, width=device-width">
	<meta name="mobile-web-app-capable" content="yes">
	<meta name="apple-mobile-web-app-capable" content="yes">
	<meta http-equiv="X-UA-Compatible" content="IE=edge"/>	
	<title>Waste Management System</title>
	<link rel="shortcut icon" href="favicon.ico">
	<link rel="stylesheet" href="css/jquery.mobile.structure.css">
	<link rel="stylesheet" href="css/jquery.mobile.theme.css">
	<link rel="stylesheet" href="css/jquery.mobile.icons.css">
	<link rel="stylesheet" href="css/wms.css">
	<link rel="stylesheet" href="css/wms.add.css">
	<script src="js/jquery.js"></script>
	<script src="js/jquery.mobile.js"></script>
	<script src="js/wms.js"></script>	
</head>
<body>

<div data-role="page">

	<?php
	include('js/header.php');
	?>
	<?php
	include('js/menu.php');
	?>
		
	<div role="main" class="ui-content">
	

		<?php
		if (isset($_GET['search']))
		{
			$search = $_GET['search'];
		}
		else
		{
			$search = '$$$';
		}
		if(hasPermission("contact_new"))
		{		
		?>	
		<a class="ui-btn" href="list_contact_new.php" data-ajax="false"><b>neuen Kunden anlegen</b></a>
		<?php
		}
		?>
		
		<form id="myform" data-ajax="false" action="./list_contact.php" method="GET" autocomplete="off">
		<input placeholder="Suchbegriff für Datenbanksuche" id="search" name="search" value="<?php if ($search=='$$$') echo ''; else echo $search;?>">		
		<input id="submit" type="submit" class="ui-shadow ui-btn ui-corner-all" data-icon="action" data-iconpos="top" value="Suche">		
		</form>
		
		<ul data-role="listview" data-inset="true" data-filter="true" data-filter-placeholder="Filter über gefundene Datensätze">				
		<?php
		
			$cat = pg_query($db, 'select 
					category.description as cat, 
					category.id as id, 
					count(category.description) as cnt 
				from 
					contact, 
					category,
					card 
				where 
					contact.category = category.id and
					card.contact = contact.id and
					card.deliverytype = \'wms\' and
					(
						upper(contact.id) like upper(\'%' . $search .'%\') or
						upper(card.id) like upper(\'%' . $search .'%\') or
						upper(contact.name1) like upper(\'%' . $search .'%\') or
						upper(contact.name2) like upper(\'%' . $search .'%\') or
						upper(contact.street) like upper(\'%' . $search .'%\') or
						upper(contact.zip) like upper(\'%' . $search .'%\') or
						upper(contact.city) like upper(\'%' . $search .'%\') or
						upper(card.description) like upper(\'%' . $search .'%\') or							
						upper(card.street) like upper(\'%' . $search .'%\') or
						upper(card.zip) like upper(\'%' . $search .'%\') or
						upper(card.city) like upper(\'%' . $search .'%\') 
					)					
				group by 
					category.description, 
					category.id 
				order by 
					category.description');
			
			while ($cow = pg_fetch_assoc($cat)) {
			?>
						
				<li data-role="list-divider"><?php echo $cow['cat']; ?><span class="ui-li-count"><?php echo $cow['cnt']; ?></span></li>
			
				<?php 
		
				$res = pg_query($db, "select distinct
						c.id as id, 
						c.debitor_id, 
						c.name1, 
						c.name2, 
						c.zip, 
						c.city, 
						c.street, 
						c.street_extension, 
						c.remark 
					from 
						contact c,
						card cc 
					where 
						cc.contact = c.id and cc.deliverytype = 'wms' and 
						c.category = '".$cow['id']."' and
						(
							upper(c.id) like upper('%" . $search ."%') or
							upper(cc.id) like upper('%" . $search ."%') or
							upper(c.name1) like upper('%" . $search ."%') or
							upper(c.name2) like upper('%" . $search ."%') or
							upper(c.street) like upper('%" . $search ."%') or
							upper(c.zip) like upper('%" . $search ."%') or
							upper(c.city) like upper('%" . $search ."%') or
							upper(cc.description) like upper('%" . $search ."%') or
							upper(cc.street) like upper('%" . $search ."%') or
							upper(cc.zip) like upper('%" . $search ."%') or
							upper(cc.city) like upper('%" . $search ."%')
						)						
					order 
						by name1							
				");
				
				while ($row = pg_fetch_assoc($res)) {
				
					?>
					
					<li>
					<a class="href" href="#">
					<h2><?php echo $row['name1'].' '.$row['name2']; ?></h2>
					<p>
					Kunde: <?php echo $row['id']; ?><br>
					Strasse: <?php echo $row['street'].' '.$row['street_extension']; ?><br>
					Ort: <?php echo $row['zip'].' '.$row['city']; ?><br>
					Debitor: <?php echo $row['debitor_id']; ?><br>
					<br>
					<?php echo $row['remark']; ?>
					
					<?php

					$pri = pg_query($db, 'select 
							quantity::integer::text as quantity, 
							quantity_preset::integer::text as quantity_preset,
							id, 
							to_char(discount_percent, \'9G990D00\') as discount_percent, 
							paymenttype,
							description,
							country,
							zip,
							city,
							street
						from 
							card 
						where 
							contact = \''.$row['id'].'\' and
							deliverytype = \'wms\'  
						order by 
							id desc');
					
					while ($pow = pg_fetch_assoc($pri)) {
					?>
					
					<?php echo $pow['description'] . ': ' . $pow['street'] . ', ' . $pow['country'] . ' ' . $pow['zip'] . ' ' . $pow['city']; ?><br>
					Vertrag <?php echo $pow['id']; ?><br>
					mit <?php echo $pow['discount_percent']; ?> Prozent Rabatt für <?php echo $pow['paymenttype']; ?> Zahlung<br>
					Freimenge/Jahr: <?php echo $pow['quantity_preset']; ?><br>
					Freimenge aktuell: <?php echo $pow['quantity']; ?><br><br> 
					
					<?php 
					}
					
					?>
					
					</p>
					</a>
					</li>
			
					<?php 
							
				}
				
			}
						
		?>
		</ul>
					
	</div>

	<?php
	include('js/footer.php');
	?>
			
</div>

</body>
</html>
